<?xml version="1.0" encoding="UTF-8"?>
<panel version="14">
 <properties>
  <prop name="Name">
   <prop name="en_US.utf8">RDB Overview</prop>
  </prop>
  <prop name="Size">800 290</prop>
  <prop name="BackColor">_3DFace</prop>
  <prop name="RefPoint">10 10</prop>
  <prop name="InitAndTermRef">True</prop>
  <prop name="SendClick">False</prop>
  <prop name="RefFileName"></prop>
  <prop name="DPI">96</prop>
  <prop name="layoutType">None</prop>
 </properties>
 <events>
  <script name="ScopeLib" isEscaped="1"><![CDATA[#uses &quot;fwGeneral/fwExceptionHandling.ctl&quot;
#uses &quot;fwRDBArchiver/fwRDBArchiver.ctl&quot;
#uses &quot;CtrlPv2Admin&quot;

mixed _getConfigFileRDBValue(string key, mixed defaultValue) {
  return _getConfigFileValue(&quot;ValueArchiveRDB&quot;, key, defaultValue);
}

mixed _getConfigFileValue(string section, string key, mixed defaultValue) {
  string configFile = getPath(CONFIG_REL_PATH, &quot;config&quot;);
  return paCfgReadValueDflt(configFile, section, key, defaultValue);
}

void _setConfigFileRDBValue(string key, mixed value) {
  _setConfigFileValue(&quot;ValueArchiveRDB&quot;, key, value);
}

void _setConfigFileValue(string section, string key, mixed value, bool replace=true) {
  int err;
  dyn_string exceptionInfo = makeDynString();
  
  err = _fwRDBArchiver_setConfigFileValue (section, key, value, replace, exceptionInfo);
  if(err &lt; 0)
    fwExceptionHandling_display(exceptionInfo);
}

void _deleteConfigFileRDBValue(string key) {
  _deleteConfigFileValue(&quot;ValueArchiveRDB&quot;, key);
}

void _deleteConfigFileValue(string section, string key, mixed value=&quot;&quot;) {
  string configFile = getPath(CONFIG_REL_PATH, &quot;config&quot;);
  if(value == &quot;&quot;)
    paCfgDeleteValue(configFile, section, key);
  else
    paCfgDeleteValue(configFile, section, key, value);
}

void setFontBold(string shap, bool bold) {
  string fontStr;
  getValue(shap, &quot;font&quot;, fontStr);
  
  dyn_string fontStrSplitted = strsplit(fontStr, &quot;,&quot;);
  fontStrSplitted[5] = bold ? 75 : 50;
  
  fontStr = strjoin(fontStrSplitted, &quot;,&quot;);
  setValue(shap, &quot;font&quot;, fontStr);
}

string strjoin(dyn_string strList, string delim=&quot; &quot;) {
  string toReturn = &quot;&quot;;
  
  for(int i=1 ; i &lt;= dynlen(strList) ; i++) {
    if(i &gt; 1)
      toReturn += delim;
    toReturn += strList[i];
  }
  
  return toReturn;
}

int dynContainsStrIgnoreCase(dyn_string array, string value) {
  int pos=0;
  value = strtolower(value);
  
  for(int i=1 ; i &lt;= dynlen(array) ; i++) {
    if(strtolower(array[i]) == value) {
      pos = i;
      break;
    }
  }
  
  return pos;
}

// ------------------------------------------------------------------------------------------------

void showUserFeedback(bool bShow)
{
  progressBar.visible(bShow);
  feedbackArrow.visible(bShow);
  feedbackText.visible(bShow);
}]]></script>
  <script name="Initialize" isEscaped="1"><![CDATA[main()
{
  modeSelectionCombobox.selectedPos(2);
  
  showRDBConnectionState();
}

showRDBConnectionState()
{
  dyn_errClass err;

  if( !dpExists( &quot;_RDBArchive.dbConnection.connected:_online.._value&quot;))
  {
    setValue(&quot;connectionStateRectangle&quot;, &quot;color&quot;, &quot;_dpdoesnotexist&quot;);
    setValue(&quot;connectionStateText&quot;, &quot;text&quot;, &quot;N/A&quot;);
    return;
  }

  dpConnect(&quot;updateConnectionStateCB&quot;,
            &quot;_RDBArchive.dbConnection.connected:_online.._value&quot;);
  
  err = getLastError();
  if (dynlen(err) &gt; 0)
  {
    setValue(&quot;connectionStateRectangle&quot;, &quot;color&quot;, &quot;_dpdoesnotexist&quot;);
    setValue(&quot;connectionStateText&quot;, &quot;text&quot;, &quot;N/A&quot;);
  }
}


updateConnectionStateCB(string dp, bool boNewValue)
{
  setValue(&quot;connectionStateText&quot;, &quot;text&quot;, (boNewValue==true)?&quot;Connected&quot;:&quot;Disconnected&quot;);
  setValue(&quot;connectionStateRectangle&quot;, &quot;color&quot;, (boNewValue==true)?&quot;green&quot;:&quot;red&quot;);
}]]></script>
 </events>
 <shapes>
  <shape layerId="0" Name="CONFIGRDB_BTN" shapeType="PUSH_BUTTON">
   <properties>
    <prop name="serialId">1</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">370 158.999</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_ButtonText</prop>
    <prop name="BackColor">_Button</prop>
    <prop name="TabOrder">1</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8">Setup the connection to the database.</prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">715 39</prop>
    <prop name="Size">75 25</prop>
    <prop name="BorderStyle">Normal</prop>
    <prop name="Text">
     <prop name="en_US.utf8">Connect</prop>
    </prop>
    <prop name="IsToggle">True</prop>
   </properties>
   <events>
    <script name="Clicked" isEscaped="1"><![CDATA[main()
{
  int err;
  dyn_string exceptionInfo = makeDynString();
  
  progressBar.totalSteps(3);
  progressBar.progress(0);
  showUserFeedback(true);
  this.toggleState(true);
  
  if((cb_dbhost.text() == &quot;&quot;) || (cb_schemaUser.text() == &quot;&quot;) || (USER_PWD.text() == &quot;&quot;)) {  
    this.toggleState(false);
    return;
  }
  
  feedbackText.text(&quot;Configuring RDB&quot;);
  
  err = fwRDBArchiver_configRDB(cb_dbhost.text(), cb_schemaUser.text(), USER_PWD.text(), exceptionInfo);
  if(err &lt; 0) {
    fwExceptionHandling_display(exceptionInfo);
    this.toggleState(false);
    showUserFeedback(false);
    return;
  }
  
  progressBar.progress(1);
  feedbackText.text(&quot;Adding RDB manager&quot;);
  
  // If already there, nothing will be done
  err = _fwRDBArchiver_addRDBManager(exceptionInfo);
  if(err &lt; 0) {
    fwExceptionHandling_display(exceptionInfo);
    this.toggleState(false);
    showUserFeedback(false);
    return;
  }
  
  progressBar.progress(2);
  feedbackText.text(&quot;Restarting RDB manager&quot;);
  
  err = fwInstallationManager_restart(&quot;WCCOArdb&quot;, &quot;-num 99&quot;);
  if(err &lt; 0) {
    fwExceptionHandling_display(exceptionInfo);
    this.toggleState(false);
    showUserFeedback(false);
    return;
  }
  
  progressBar.progress(3);
  
  this.toggleState(false);
  showUserFeedback(false);
}]]></script>
    <script name="Initialize" isEscaped="1"><![CDATA[main()
{
  if((cb_dbhost.text() != &quot;&quot;) &amp;&amp; (cb_schemaUser.text() != &quot;&quot;) &amp;&amp; (USER_PWD.text() != &quot;&quot;))
    CONFIGRDB_BTN.enabled(true);
  else
    CONFIGRDB_BTN.enabled(false);
}]]></script>
   </events>
  </shape>
  <shape layerId="0" Name="PRIMITIVE_TEXT5" shapeType="PRIMITIVE_TEXT">
   <properties>
    <prop name="serialId">2</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">299 44</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">2</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8">The database user.</prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="DashBackColor">_Transparent</prop>
    <prop name="AntiAliased">False</prop>
    <prop name="LineType">[solid,oneColor,JoinBevel,CapButt,1]</prop>
    <prop name="BorderZoomable">False</prop>
    <prop name="FillType">[outline]</prop>
    <prop name="Location">299 44</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Text">
     <prop name="en_US.utf8">Schema:</prop>
    </prop>
    <prop name="Distance">2</prop>
    <prop name="BorderOffset">2</prop>
    <prop name="Bordered">False</prop>
    <prop name="Fit">True</prop>
    <prop name="Transformable">True</prop>
    <prop name="TextFormat">[0s,,,AlignLeft]</prop>
   </properties>
  </shape>
  <shape layerId="0" Name="PRIMITIVE_TEXT8" shapeType="PRIMITIVE_TEXT">
   <properties>
    <prop name="serialId">3</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">500 44</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">3</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8">The database user password.</prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="DashBackColor">_Transparent</prop>
    <prop name="AntiAliased">False</prop>
    <prop name="LineType">[solid,oneColor,JoinBevel,CapButt,1]</prop>
    <prop name="BorderZoomable">False</prop>
    <prop name="FillType">[outline]</prop>
    <prop name="Location">500 44</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Text">
     <prop name="en_US.utf8">Password:</prop>
    </prop>
    <prop name="Distance">2</prop>
    <prop name="BorderOffset">2</prop>
    <prop name="Bordered">False</prop>
    <prop name="Fit">True</prop>
    <prop name="Transformable">True</prop>
    <prop name="TextFormat">[0s,,,AlignLeft]</prop>
   </properties>
  </shape>
  <shape layerId="0" Name="USER_PWD" shapeType="TEXT_FIELD">
   <properties>
    <prop name="serialId">4</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">88 149.999</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">4</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8">The database user password.</prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">568 40</prop>
    <prop name="Size">137 23</prop>
    <prop name="BorderStyle">Normal</prop>
    <prop name="Editable">True</prop>
    <prop name="TextFormat">[0S,,,AlignLeft]</prop>
   </properties>
   <events>
    <script name="TextChanged" isEscaped="1"><![CDATA[main(string newText)
{
  if((cb_dbhost.text() != &quot;&quot;) &amp;&amp; (cb_schemaUser.text() != &quot;&quot;) &amp;&amp; (USER_PWD.text() != &quot;&quot;))
    CONFIGRDB_BTN.enabled(true);
  else
    CONFIGRDB_BTN.enabled(false);
}]]></script>
   </events>
  </shape>
  <shape layerId="0" Name="PRIMITIVE_TEXT16" shapeType="PRIMITIVE_TEXT">
   <properties>
    <prop name="serialId">5</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">130 44</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">5</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8">The database instance.</prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="DashBackColor">_Transparent</prop>
    <prop name="AntiAliased">False</prop>
    <prop name="LineType">[solid,oneColor,JoinBevel,CapButt,1]</prop>
    <prop name="BorderZoomable">False</prop>
    <prop name="FillType">[outline]</prop>
    <prop name="Location">130 44</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Text">
     <prop name="en_US.utf8">DB:</prop>
    </prop>
    <prop name="Distance">2</prop>
    <prop name="BorderOffset">2</prop>
    <prop name="Bordered">False</prop>
    <prop name="Fit">True</prop>
    <prop name="Transformable">True</prop>
    <prop name="TextFormat">[0s,,,AlignLeft]</prop>
   </properties>
  </shape>
  <shape layerId="0" Name="cb_dbhost" shapeType="COMBO_BOX">
   <properties>
    <prop name="serialId">15</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">157 40</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">15</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">157 40</prop>
    <prop name="Size">137 23</prop>
    <prop name="Listitems"/>
    <prop name="Editable">True</prop>
   </properties>
   <events>
    <script name="Changed" isEscaped="1"><![CDATA[main()
{
  if((cb_dbhost.text() != &quot;&quot;) &amp;&amp; (cb_schemaUser.text() != &quot;&quot;) &amp;&amp; (USER_PWD.text() != &quot;&quot;))
    CONFIGRDB_BTN.enabled(true);
  else
    CONFIGRDB_BTN.enabled(false);
}]]></script>
    <script name="Initialize" isEscaped="1"><![CDATA[dyn_string tnsnames;

main()
{
  string tnsAdmin = getenv(&quot;TNS_ADMIN&quot;);
  if(tnsAdmin == &quot;&quot;)
    tnsAdmin = &quot;/etc&quot;;
  string tnsnamesOra = tnsAdmin + &quot;/tnsnames.ora&quot;;
  
  if(!isfile(tnsnamesOra))
    return; // Silent exit
  
  string outputFile = tmpnam();
  if(_WIN32) {
    strreplace(tnsnamesOra, &quot;\\\\cern.ch\\dfs\\&quot;, &quot;G:\\&quot;); // grep can't access files in form \\netdrive\path
    strreplace(tnsnamesOra, &quot;/&quot;, &quot;\\&quot;);
  }
  
  system(&quot;grep -E \&quot;^([^#()\\W[:space:]][[:alnum:]._-]*(?:[.][[:alnum:]]*\\s?=)?)\&quot; &quot; + tnsnamesOra + &quot; | cut -d= -f1 | cut -d \&quot; \&quot; -f1 | sort -f &gt; &quot; + outputFile);
  
  string tnsnamesAll;
  if(!fileToString(outputFile, tnsnamesAll))
    return; // Silent exit
  remove(outputFile);
  
  tnsnames = strsplit(tnsnamesAll, &quot;\n&quot;);
  this.items(tnsnames);
  
  EP_textFieldIn();
}

EP_textFieldIn() {
dyn_errClass err;

  if(!dpExists( &quot;_RDBArchive.db.host:_online.._value&quot;)) {
    setValue(&quot;&quot;, &quot;color&quot;, &quot;_dpdoesnotexist&quot;);
    return;
  }

  dpConnect(&quot;EP_textFieldInCB&quot;,
            &quot;_RDBArchive.db.host:_online.._value&quot;);
  err = getLastError();
  if (dynlen(err) &gt; 0)
    setValue(&quot;&quot;, &quot;color&quot;, &quot;_dpdoesnotexist&quot;);
}


EP_textFieldInCB(string dp, string sNewValue) {
  if(sNewValue == &quot;&quot;)
    sNewValue = _getConfigFileRDBValue(&quot;Db&quot;, &quot;&quot;);
  
  int pos = dynContainsStrIgnoreCase(tnsnames, sNewValue);
  if(pos)
    this.selectedPos(pos);
  else
    this.text(sNewValue);
}]]></script>
    <script name="KeyboardFocusOut" isEscaped="1"><![CDATA[main()
{
  if((cb_dbhost.text() != &quot;&quot;) &amp;&amp; (cb_schemaUser.text() != &quot;&quot;) &amp;&amp; (USER_PWD.text() != &quot;&quot;))
    CONFIGRDB_BTN.enabled(true);
  else
    CONFIGRDB_BTN.enabled(false);
}]]></script>
   </events>
  </shape>
  <shape layerId="0" Name="cb_schemaUser" shapeType="COMBO_BOX">
   <properties>
    <prop name="serialId">16</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">353 39.999</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">16</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">353 40</prop>
    <prop name="Size">137 23</prop>
    <prop name="Listitems"/>
    <prop name="Editable">True</prop>
   </properties>
   <events>
    <script name="Changed" isEscaped="1"><![CDATA[main()
{
  if((cb_dbhost.text() != &quot;&quot;) &amp;&amp; (cb_schemaUser.text() != &quot;&quot;) &amp;&amp; (USER_PWD.text() != &quot;&quot;))
    CONFIGRDB_BTN.enabled(true);
  else
    CONFIGRDB_BTN.enabled(false);
}]]></script>
    <script name="Initialize" isEscaped="1"><![CDATA[dyn_string userList;

main()
{
  // Don't even try if the empty password has been set (by the component init script)
  string pwd;
  string emptyPwd = &quot;&quot;, pwd;
  cryptAESRDB(&quot;&quot;, emptyPwd);
  dpGet(&quot;_RDBArchive.db.password&quot;, pwd);
  if(pwd == emptyPwd)
    return;
  
  userList = makeDynString();
  dyn_string exceptionInfo = makeDynString();
  int err = fwRDBArchiver_listRDBUsers(userList, exceptionInfo);
  if(err &lt; 0) {
    //fwExceptionHandling_display(exceptionInfo); // Silent, no connection probably
    return;
  }
    
  this.items(userList);
  
  EP_textFieldIn();
}

EP_textFieldIn() {
dyn_errClass err;

  if(!dpExists( &quot;_RDBArchive.db.user:_online.._value&quot;)) {
    setValue(&quot;&quot;, &quot;color&quot;, &quot;_dpdoesnotexist&quot;);
    return;
  }

  dpConnect(&quot;EP_textFieldInCB&quot;,
            &quot;_RDBArchive.db.user:_online.._value&quot;);
  err = getLastError();
  if (dynlen(err) &gt; 0)
    setValue(&quot;&quot;, &quot;color&quot;, &quot;_dpdoesnotexist&quot;);
}

EP_textFieldInCB(string dp, string sNewValue) {
  if(sNewValue == &quot;&quot;)
    sNewValue = _getConfigFileRDBValue(&quot;DbUser&quot;, &quot;&quot;);
  
  int pos = dynContainsStrIgnoreCase(userList, sNewValue);
  if(pos)
    this.selectedPos(pos);
  else
    this.text(sNewValue);
}]]></script>
    <script name="KeyboardFocusOut" isEscaped="1"><![CDATA[main()
{
  if((cb_dbhost.text() != &quot;&quot;) &amp;&amp; (cb_schemaUser.text() != &quot;&quot;) &amp;&amp; (USER_PWD.text() != &quot;&quot;))
    CONFIGRDB_BTN.enabled(true);
  else
    CONFIGRDB_BTN.enabled(false);
}]]></script>
   </events>
  </shape>
  <shape layerId="0" Name="cb_queryRDBdirect" shapeType="CHECK_BOX">
   <properties>
    <prop name="serialId">17</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">207.998 309.994</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_3DText</prop>
    <prop name="BackColor">_3DFace</prop>
    <prop name="TabOrder">17</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8">&lt;b>Default=0.&lt;/b>&lt;br/>&lt;br/>Indicates the mode of database write queries:&lt;br/>&lt;br/>0 = Standard CTRL read functions (dpGet...()) via the PVSS Event Manager and the PVSS Data Manager.&lt;br/>&lt;br/>1 = The standard CTRL read functions (dpGet...()) are redirected to the direct read functions in the Control add-on.&lt;br/>&lt;br/>&lt;b>CAUTION:&lt;/b>&lt;br/>If you use &lt;i>queryRDBdirect=1&lt;/i> and query DPs using the event screen, enter the DPs or *.* for the query. Otherwise the event screen does not show the DPs.</prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">190 105</prop>
    <prop name="Size">190 20</prop>
    <prop name="Vertical">False</prop>
    <prop name="Listitems">
     <prop name="Item">
      <prop name="Text">
       <prop name="en_US.utf8">ctrl</prop>
      </prop>
      <prop name="Select">False</prop>
     </prop>
     <prop name="Item">
      <prop name="Text">
       <prop name="en_US.utf8">ui</prop>
      </prop>
      <prop name="Select">False</prop>
     </prop>
    </prop>
   </properties>
   <events>
    <script name="Clicked" isEscaped="1"><![CDATA[main(int button, int state)
{
  bool defaultt = true;
  if(button == 0) { // CTRL
    if(this.state(1) == 1)
      defaultt = false;
    
    if(state == 0) {
      _deleteConfigFileValue(&quot;ctrl&quot;, &quot;queryRDBdirect&quot;);
    }else{
      _setConfigFileValue(&quot;ctrl&quot;, &quot;queryRDBdirect&quot;, 1);
      defaultt = false;
    }
  }else{ // UI
    if(this.state(0) == 1)
      defaultt = false;
    
    if(state == 0) {
      _deleteConfigFileValue(&quot;ui&quot;, &quot;queryRDBdirect&quot;);
    }else{
      _setConfigFileValue(&quot;ui&quot;, &quot;queryRDBdirect&quot;, 1);
      defaultt = false;
    }
  }  
  
  if(defaultt)
    setFontBold(&quot;pt_queryRDBdirect&quot;, false);
  else
    setFontBold(&quot;pt_queryRDBdirect&quot;, true);
}]]></script>
    <script name="Initialize" isEscaped="1"><![CDATA[main()
{
  int valueCtrl = _getConfigFileValue(&quot;ctrl&quot;, &quot;queryRDBdirect&quot;, 0);
  int valueUi = _getConfigFileValue(&quot;ui&quot;, &quot;queryRDBdirect&quot;, 0);
  
  bool defaultt = true;
  if(valueCtrl == 0)
    this.state(0, 0);
  else{
    this.state(0, 1);
    defaultt = false;
  }
  
  if(valueUi == 0)
    this.state(1, 0);
  else{
    this.state(1, 1);
    defaultt = false;
  }
  
  if(defaultt)
    setFontBold(&quot;pt_queryRDBdirect&quot;, false);
  else
    setFontBold(&quot;pt_queryRDBdirect&quot;, true);
}]]></script>
   </events>
  </shape>
  <shape layerId="0" Name="cb_queryFunction" shapeType="CHECK_BOX">
   <properties>
    <prop name="serialId">18</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">207.998 349.994</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_3DText</prop>
    <prop name="BackColor">_3DFace</prop>
    <prop name="TabOrder">18</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8">&lt;b>Default=0.&lt;/b>&lt;br/>&lt;br/>With the config entry &lt;i>queryFunction=1&lt;/i> a database function is used for dpGetPeriod() instead of a query. Therefore, the limitations such as the number of tables and the length of the SQL statement cease to exist.&lt;br/>&lt;br/>With &lt;i>queryFunction=0&lt;/i>, a query is used as so far.&lt;br/>&lt;br/>The entry can be used in ValueArchiveRDB, UI and Ctrl sections. In the Ctrl section it is necessary to set also the config entry &lt;i>queryRDBdirect=1&lt;/i> in addition to the queryFunction config entry.</prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">190 139</prop>
    <prop name="Size">190 20</prop>
    <prop name="Vertical">False</prop>
    <prop name="Listitems">
     <prop name="Item">
      <prop name="Text">
       <prop name="en_US.utf8">ctrl</prop>
      </prop>
      <prop name="Select">False</prop>
     </prop>
     <prop name="Item">
      <prop name="Text">
       <prop name="en_US.utf8">ui</prop>
      </prop>
      <prop name="Select">False</prop>
     </prop>
    </prop>
   </properties>
   <events>
    <script name="Clicked" isEscaped="1"><![CDATA[main(int button, int state)
{
  bool defaultt = true;
  if(button == 0) { // CTRL
    if(this.state(1) == 1)
      defaultt = false;
    
    if(state == 0)
      _deleteConfigFileRDBValue(&quot;queryFunction&quot;);
    else{
      _setConfigFileRDBValue(&quot;queryFunction&quot;, 1);
      defaultt = false;
    }
  }else{ // UI
    if(this.state(0) == 1)
      defaultt = false;
    
    if(state == 0)
      _deleteConfigFileValue(&quot;ui&quot;, &quot;queryFunction&quot;);
    else{
      _setConfigFileValue(&quot;ui&quot;, &quot;queryFunction&quot;, 1);
      defaultt = false;
    }
  }  
  
  if(defaultt)
    setFontBold(&quot;pt_queryFunction&quot;, false);
  else
    setFontBold(&quot;pt_queryFunction&quot;, true);
}]]></script>
    <script name="Initialize" isEscaped="1"><![CDATA[main()
{
  int valueCtrl = _getConfigFileRDBValue(&quot;queryFunction&quot;, 0); // The value for ctrl actually comes from ValueRDBArchive section
  int valueUi = _getConfigFileValue(&quot;ui&quot;, &quot;queryFunction&quot;, 0);
  
  bool defaultt = true;
  if(valueCtrl == 0)
    this.state(0, 0);
  else{
    this.state(0, 1);
    defaultt = false;
  }
  
  if(valueUi == 0)
    this.state(1, 0);
  else{
    this.state(1, 1);
    defaultt = false;
  }
  
  if(defaultt)
    setFontBold(&quot;pt_queryFunction&quot;, false);
  else
    setFontBold(&quot;pt_queryFunction&quot;, true);
}]]></script>
   </events>
  </shape>
  <shape layerId="0" Name="FRAME7" shapeType="FRAME">
   <properties>
    <prop name="serialId">27</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">430 522</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">{0,0,0}</prop>
    <prop name="TabOrder">27</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="DashBackColor">_Transparent</prop>
    <prop name="AntiAliased">False</prop>
    <prop name="LineType">[solid,oneColor,JoinMiter,CapButt,0]</prop>
    <prop name="BorderZoomable">False</prop>
    <prop name="FillType">[outline]</prop>
    <prop name="Geometry">6.65811 0 0 2.375 -2852.99 -1156.75</prop>
    <prop name="BorderStyle">3D</prop>
    <prop name="Text">
     <prop name="en_US.utf8">Basic options</prop>
    </prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">430 522</prop>
    <prop name="Size">118 65</prop>
   </properties>
  </shape>
  <shape layerId="0" Name="pt_queryRDBdirect" shapeType="PRIMITIVE_TEXT">
   <properties>
    <prop name="serialId">28</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">20.9981 106.994</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">28</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8">&lt;b>Default=0.&lt;/b>&lt;br/>&lt;br/>Indicates the mode of database write queries:&lt;br/>&lt;br/>0 = Standard CTRL read functions (dpGet...()) via the PVSS Event Manager and the PVSS Data Manager.&lt;br/>&lt;br/>1 = The standard CTRL read functions (dpGet...()) are redirected to the direct read functions in the Control add-on.&lt;br/>&lt;br/>&lt;b>CAUTION:&lt;/b>&lt;br/>If you use &lt;i>queryRDBdirect=1&lt;/i> and query DPs using the event screen, enter the DPs or *.* for the query. Otherwise the event screen does not show the DPs.</prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="DashBackColor">_Transparent</prop>
    <prop name="AntiAliased">False</prop>
    <prop name="LineType">[solid,oneColor,JoinBevel,CapButt,1]</prop>
    <prop name="BorderZoomable">False</prop>
    <prop name="FillType">[outline]</prop>
    <prop name="Location">20.9981 106.994</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Text">
     <prop name="en_US.utf8">queryRDBDirect:</prop>
    </prop>
    <prop name="Distance">2</prop>
    <prop name="BorderOffset">2</prop>
    <prop name="Bordered">False</prop>
    <prop name="Fit">True</prop>
    <prop name="Transformable">True</prop>
    <prop name="TextFormat">[0s,,,AlignLeft]</prop>
   </properties>
  </shape>
  <shape layerId="0" Name="pt_queryFunction" shapeType="PRIMITIVE_TEXT">
   <properties>
    <prop name="serialId">29</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">20.9981 139.994</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">29</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8">&lt;b>Default=0.&lt;/b>&lt;br/>&lt;br/>With the config entry &lt;i>queryFunction=1&lt;/i> a database function is used for dpGetPeriod() instead of a query. Therefore, the limitations such as the number of tables and the length of the SQL statement cease to exist.&lt;br/>&lt;br/>With &lt;i>queryFunction=0&lt;/i>, a query is used as so far.&lt;br/>&lt;br/>The entry can be used in ValueArchiveRDB, UI and Ctrl sections. In the Ctrl section it is necessary to set also the config entry &lt;i>queryRDBdirect=1&lt;/i> in addition to the queryFunction config entry.</prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="DashBackColor">_Transparent</prop>
    <prop name="AntiAliased">False</prop>
    <prop name="LineType">[solid,oneColor,JoinBevel,CapButt,1]</prop>
    <prop name="BorderZoomable">False</prop>
    <prop name="FillType">[outline]</prop>
    <prop name="Location">20.9981 139.994</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Text">
     <prop name="en_US.utf8">queryFunction:</prop>
    </prop>
    <prop name="Distance">2</prop>
    <prop name="BorderOffset">2</prop>
    <prop name="Bordered">False</prop>
    <prop name="Fit">True</prop>
    <prop name="Transformable">True</prop>
    <prop name="TextFormat">[0s,,,AlignLeft]</prop>
   </properties>
  </shape>
  <shape layerId="0" Name="pt_maxBlocks" shapeType="PRIMITIVE_TEXT">
   <properties>
    <prop name="serialId">34</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">470 173</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">34</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8">The DB has an internal block buffer. This value specifies how many blocks are in the buffer. Therefore, this value specifies how many blocks may exist at most.</prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="DashBackColor">_Transparent</prop>
    <prop name="AntiAliased">False</prop>
    <prop name="LineType">[solid,oneColor,JoinBevel,CapButt,1]</prop>
    <prop name="BorderZoomable">False</prop>
    <prop name="FillType">[outline]</prop>
    <prop name="Location">470 173</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Text">
     <prop name="en_US.utf8">Maximum blocks:</prop>
    </prop>
    <prop name="Distance">2</prop>
    <prop name="BorderOffset">2</prop>
    <prop name="Bordered">False</prop>
    <prop name="Fit">True</prop>
    <prop name="Transformable">True</prop>
    <prop name="TextFormat">[0s,,,AlignLeft]</prop>
   </properties>
  </shape>
  <shape layerId="0" Name="pt_flushInterval" shapeType="PRIMITIVE_TEXT">
   <properties>
    <prop name="serialId">35</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">470 107</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">35</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8">0 = flush interval deactivated.&lt;br/>&lt;br/>Otherwise a block (also when it is not full) is written in the set time interval (milliseconds) into the database.</prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="DashBackColor">_Transparent</prop>
    <prop name="AntiAliased">False</prop>
    <prop name="LineType">[solid,oneColor,JoinBevel,CapButt,1]</prop>
    <prop name="BorderZoomable">False</prop>
    <prop name="FillType">[outline]</prop>
    <prop name="Location">470 107</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Text">
     <prop name="en_US.utf8">Flush interval [ms]:</prop>
    </prop>
    <prop name="Distance">2</prop>
    <prop name="BorderOffset">2</prop>
    <prop name="Bordered">False</prop>
    <prop name="Fit">True</prop>
    <prop name="Transformable">True</prop>
    <prop name="TextFormat">[0s,,,AlignLeft]</prop>
   </properties>
  </shape>
  <shape layerId="0" Name="pt_maxEntries" shapeType="PRIMITIVE_TEXT">
   <properties>
    <prop name="serialId">36</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">470 206</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">36</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8">Number of entries per block. If this value is exceeded, a new block is started.</prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="DashBackColor">_Transparent</prop>
    <prop name="AntiAliased">False</prop>
    <prop name="LineType">[solid,oneColor,JoinBevel,CapButt,1]</prop>
    <prop name="BorderZoomable">False</prop>
    <prop name="FillType">[outline]</prop>
    <prop name="Location">470 206</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Text">
     <prop name="en_US.utf8">Maximum entries:</prop>
    </prop>
    <prop name="Distance">2</prop>
    <prop name="BorderOffset">2</prop>
    <prop name="Bordered">False</prop>
    <prop name="Fit">True</prop>
    <prop name="Transformable">True</prop>
    <prop name="TextFormat">[0s,,,AlignLeft]</prop>
   </properties>
  </shape>
  <shape layerId="0" Name="pt_dbWriteDelay" shapeType="PRIMITIVE_TEXT">
   <properties>
    <prop name="serialId">37</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">470 140</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">37</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8">Interval in [ms] between two write attempts.</prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="DashBackColor">_Transparent</prop>
    <prop name="AntiAliased">False</prop>
    <prop name="LineType">[solid,oneColor,JoinBevel,CapButt,1]</prop>
    <prop name="BorderZoomable">False</prop>
    <prop name="FillType">[outline]</prop>
    <prop name="Location">470 140</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Text">
     <prop name="en_US.utf8">DB write delay [ms]:</prop>
    </prop>
    <prop name="Distance">2</prop>
    <prop name="BorderOffset">2</prop>
    <prop name="Bordered">False</prop>
    <prop name="Fit">True</prop>
    <prop name="Transformable">True</prop>
    <prop name="TextFormat">[0s,,,AlignLeft]</prop>
   </properties>
  </shape>
  <shape layerId="0" Name="sb_maxBlocks" shapeType="SPIN_BUTTON">
   <properties>
    <prop name="serialId">38</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">290 430</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">38</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8">The DB has an internal block buffer. This value specifies how many blocks are in the buffer. Therefore, this value specifies how many blocks may exist at most.</prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">629 169</prop>
    <prop name="Size">150 23</prop>
    <prop name="MinimumID">0</prop>
    <prop name="MaximumID">2147483647</prop>
    <prop name="IncrAccelerator">1</prop>
    <prop name="Position">0</prop>
   </properties>
   <events>
    <script name="Changed" isEscaped="1"><![CDATA[//[SCRIPT_WIZARD_GENERATED
//[FUNCTION main
main()
{
  //[CODEBLOCK
  sdDpSet(1,&quot;_RDBArchive.buffer.maxBlocks:_original.._value&quot;,this.text());
  //]
}
//]
//]]]></script>
    <script name="Initialize" isEscaped="1"><![CDATA[//[SCRIPT_WIZARD_GENERATED
//[FUNCTION main
main()
{
  //[CONNECT
  if ( getUserPermission(1) )
  {
    //[BADVALUE
    //VALUEBAD_RULE:
    //VALUEBAD_RETURNWHENBAD:FALSE
    //VALUEBAD_RESETCOLORS:TRUE
    //]
    //[DPES
    //int &quot;_RDBArchive.buffer.maxBlocks:_online.._value&quot; 
    //]
    dyn_string dpeList;
    dyn_string varList;
    string dpe1 = sdCheckDpe(&quot;_RDBArchive.buffer.maxBlocks:_online.._value&quot;);
    if ( strlen(dpe1) )
    {
      dynAppend(dpeList, dpe1);
      dynAppend(varList, &quot;maxBlocks_online_value&quot;);
    }
    else
    {
    }

    if ( dpConnectUserData(&quot;cb_Callback_SPIN_BUTTON2&quot;, varList, true, dpeList) == -1 )    {
    }
  }
  else
  {
    //sdShowNoUserPermission
  }
  //]
}
//]
//[FUNCTION cb_Callback_SPIN_BUTTON2
void cb_Callback_SPIN_BUTTON2(
dyn_string varList, dyn_string dpeList, dyn_anytype valueList)
{
  //[VAR_LIST
  int maxBlocks_online_value;
  //]
  //[ASSIGN_VARS
  for (int i = 1; i &lt;= dynlen(varList); i++)
  {
    if ( varList[i] == &quot;maxBlocks_online_value&quot; )
      maxBlocks_online_value = valueList[i];
  }
  //]
  
  this.text(maxBlocks_online_value);
  if(maxBlocks_online_value == 1000)
    setFontBold(&quot;pt_maxBlocks&quot;, false);
  else
    setFontBold(&quot;pt_maxBlocks&quot;, true);
}
//]
//]]]></script>
   </events>
  </shape>
  <shape layerId="0" Name="sb_maxEntries" shapeType="SPIN_BUTTON">
   <properties>
    <prop name="serialId">39</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">290 460</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">39</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8">Number of entries per block. If this value is exceeded, a new block is started.</prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">629 202</prop>
    <prop name="Size">150 23</prop>
    <prop name="MinimumID">0</prop>
    <prop name="MaximumID">2147483647</prop>
    <prop name="IncrAccelerator">1</prop>
    <prop name="Position">0</prop>
   </properties>
   <events>
    <script name="Changed" isEscaped="1"><![CDATA[//[SCRIPT_WIZARD_GENERATED
//[FUNCTION main
main()
{
  //[CODEBLOCK
  sdDpSet(1,&quot;_RDBArchive.buffer.maxEntries:_original.._value&quot;,this.text());
  //]
}
//]
//]]]></script>
    <script name="Initialize" isEscaped="1"><![CDATA[//[SCRIPT_WIZARD_GENERATED
//[FUNCTION main
main()
{
  //[CONNECT
  if ( getUserPermission(1) )
  {
    //[BADVALUE
    //VALUEBAD_RULE:
    //VALUEBAD_RETURNWHENBAD:FALSE
    //VALUEBAD_RESETCOLORS:TRUE
    //]
    //[DPES
    //int &quot;_RDBArchive.buffer.maxEntries:_online.._value&quot; 
    //]
    dyn_string dpeList;
    dyn_string varList;
    string dpe1 = sdCheckDpe(&quot;_RDBArchive.buffer.maxEntries:_online.._value&quot;);
    if ( strlen(dpe1) )
    {
      dynAppend(dpeList, dpe1);
      dynAppend(varList, &quot;maxEntries_online_value&quot;);
    }
    else
    {
    }

    if ( dpConnectUserData(&quot;cb_Callback_sb_maxEntries&quot;, varList, true, dpeList) == -1 )    {
    }
  }
  else
  {
    //sdShowNoUserPermission
  }
  //]
}
//]
//[FUNCTION cb_Callback_sb_maxEntries
void cb_Callback_sb_maxEntries(
dyn_string varList, dyn_string dpeList, dyn_anytype valueList)
{
  //[VAR_LIST
  int maxEntries_online_value;
  //]
  //[ASSIGN_VARS
  for (int i = 1; i &lt;= dynlen(varList); i++)
  {
    if ( varList[i] == &quot;maxEntries_online_value&quot; )
      maxEntries_online_value = valueList[i];
  }
  //]
  
  this.text(maxEntries_online_value);
  if(maxEntries_online_value == 1000)
    setFontBold(&quot;pt_maxEntries&quot;, false);
  else
    setFontBold(&quot;pt_maxEntries&quot;, true);
}
//]
//]]]></script>
   </events>
  </shape>
  <shape layerId="0" Name="sb_flushInterval" shapeType="SPIN_BUTTON">
   <properties>
    <prop name="serialId">40</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">290 370</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">40</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8">0 = flush interval deactivated.&lt;br/>&lt;br/>Otherwise a block (also when it is not full) is written in the set time interval (milliseconds) into the database.</prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">629 103</prop>
    <prop name="Size">150 23</prop>
    <prop name="MinimumID">0</prop>
    <prop name="MaximumID">2147483647</prop>
    <prop name="IncrAccelerator">1</prop>
    <prop name="Position">0</prop>
   </properties>
   <events>
    <script name="Changed" isEscaped="1"><![CDATA[//[SCRIPT_WIZARD_GENERATED
//[FUNCTION main
main()
{
  //[CODEBLOCK
  sdDpSet(1,&quot;_RDBArchive.buffer.flushInterval:_original.._value&quot;,this.text());
  //]
}
//]
//]]]></script>
    <script name="Initialize" isEscaped="1"><![CDATA[//[SCRIPT_WIZARD_GENERATED
//[FUNCTION main
main()
{
  //[CONNECT
  if ( getUserPermission(1) )
  {
    //[BADVALUE
    //VALUEBAD_RULE:
    //VALUEBAD_RETURNWHENBAD:FALSE
    //VALUEBAD_RESETCOLORS:TRUE
    //]
    //[DPES
    //int &quot;_RDBArchive.buffer.flushInterval:_online.._value&quot; 
    //]
    dyn_string dpeList;
    dyn_string varList;
    string dpe1 = sdCheckDpe(&quot;_RDBArchive.buffer.flushInterval:_online.._value&quot;);
    if ( strlen(dpe1) )
    {
      dynAppend(dpeList, dpe1);
      dynAppend(varList, &quot;flushInterval_online_value&quot;);
    }
    else
    {
    }

    if ( dpConnectUserData(&quot;cb_Callback_sb_flushInterval&quot;, varList, true, dpeList) == -1 )    {
    }
  }
  else
  {
    //sdShowNoUserPermission
  }
  //]
}
//]
//[FUNCTION cb_Callback_sb_flushInterval
void cb_Callback_sb_flushInterval(
dyn_string varList, dyn_string dpeList, dyn_anytype valueList)
{
  //[VAR_LIST
  int flushInterval_online_value;
  //]
  //[ASSIGN_VARS
  for (int i = 1; i &lt;= dynlen(varList); i++)
  {
    if ( varList[i] == &quot;flushInterval_online_value&quot; )
      flushInterval_online_value = valueList[i];
  }
  //]
  
  this.text(flushInterval_online_value);
  if(flushInterval_online_value == 3000)
    setFontBold(&quot;pt_flushInterval&quot;, false);
  else
    setFontBold(&quot;pt_flushInterval&quot;, true);
}
//]
//]]]></script>
   </events>
  </shape>
  <shape layerId="0" Name="sb_dbWriteDelay" shapeType="SPIN_BUTTON">
   <properties>
    <prop name="serialId">41</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">290 400</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">41</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8">Interval in [ms] between two write attempts.</prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">629 136</prop>
    <prop name="Size">150 23</prop>
    <prop name="MinimumID">0</prop>
    <prop name="MaximumID">2147483647</prop>
    <prop name="IncrAccelerator">1</prop>
    <prop name="Position">0</prop>
   </properties>
   <events>
    <script name="Changed" isEscaped="1"><![CDATA[//[SCRIPT_WIZARD_GENERATED
//[FUNCTION main
main()
{
  //[CODEBLOCK
  sdDpSet(1,&quot;_RDBArchive.dbConfig.dbWriteDelay:_original.._value&quot;,this.text());
  //]
}
//]
//]]]></script>
    <script name="Initialize" isEscaped="1"><![CDATA[//[SCRIPT_WIZARD_GENERATED
//[FUNCTION main
main()
{
  //[CONNECT
  if ( getUserPermission(1) )
  {
    //[BADVALUE
    //VALUEBAD_RULE:
    //VALUEBAD_RETURNWHENBAD:FALSE
    //VALUEBAD_RESETCOLORS:TRUE
    //]
    //[DPES
    //int &quot;_RDBArchive.dbConfig.dbWriteDelay:_online.._value&quot; 
    //]
    dyn_string dpeList;
    dyn_string varList;
    string dpe1 = sdCheckDpe(&quot;_RDBArchive.dbConfig.dbWriteDelay:_online.._value&quot;);
    if ( strlen(dpe1) )
    {
      dynAppend(dpeList, dpe1);
      dynAppend(varList, &quot;dbWriteDelay_online_value&quot;);
    }
    else
    {
    }

    if ( dpConnectUserData(&quot;cb_Callback_sb_dbWriteDelay&quot;, varList, true, dpeList) == -1 )    {
    }
  }
  else
  {
    //sdShowNoUserPermission
  }
  //]
}
//]
//[FUNCTION cb_Callback_sb_dbWriteDelay
void cb_Callback_sb_dbWriteDelay(
dyn_string varList, dyn_string dpeList, dyn_anytype valueList)
{
  //[VAR_LIST
  int dbWriteDelay_online_value;
  //]
  //[ASSIGN_VARS
  for (int i = 1; i &lt;= dynlen(varList); i++)
  {
    if ( varList[i] == &quot;dbWriteDelay_online_value&quot; )
      dbWriteDelay_online_value = valueList[i];
  }
  //]
  
  this.text(dbWriteDelay_online_value);
  if(dbWriteDelay_online_value == 200)
    setFontBold(&quot;pt_dbWriteDelay&quot;, false);
  else
    setFontBold(&quot;pt_dbWriteDelay&quot;, true);
}
//]
//]]]></script>
   </events>
  </shape>
  <shape layerId="0" Name="PRIMITIVE_TEXT10" shapeType="PRIMITIVE_TEXT">
   <properties>
    <prop name="serialId">42</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">21 173</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">42</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="DashBackColor">_Transparent</prop>
    <prop name="AntiAliased">False</prop>
    <prop name="LineType">[solid,oneColor,JoinBevel,CapButt,1]</prop>
    <prop name="BorderZoomable">False</prop>
    <prop name="FillType">[outline]</prop>
    <prop name="Location">21 173</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Text">
     <prop name="en_US.utf8">Current blocks:</prop>
    </prop>
    <prop name="Distance">2</prop>
    <prop name="BorderOffset">2</prop>
    <prop name="Bordered">False</prop>
    <prop name="Fit">True</prop>
    <prop name="Transformable">True</prop>
    <prop name="TextFormat">[0s,,,AlignLeft]</prop>
   </properties>
  </shape>
  <shape layerId="0" Name="FLUSHBUFFER_BTN" shapeType="PUSH_BUTTON">
   <properties>
    <prop name="serialId">43</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">118 546</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_ButtonText</prop>
    <prop name="BackColor">_Button</prop>
    <prop name="TabOrder">43</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">280 168</prop>
    <prop name="Size">100 25</prop>
    <prop name="BorderStyle">Normal</prop>
    <prop name="Text">
     <prop name="en_US.utf8">Flush buffer</prop>
    </prop>
   </properties>
   <events>
    <script name="Clicked" isEscaped="1"><![CDATA[// SimpleCtrlScriptStart {invalid}
main()
{
  EP_setDP();
}

EP_setDP()
{
dyn_errClass err;

  dpSetWait(&quot;_RDBArchive.flushBuffer:_original.._value&quot;, true);
  err = getLastError();
  if (dynlen(err) &gt; 0)
    errorDialog(err);
}

// SimpleCtrlScript {EP_setDP}
// DP1 {dist_191:_RDBArchive.flushBuffer}
// Config1 {:_original.._value}
// Type1 {bool}
// Value1 {1}
// SimpleCtrlScriptEnd {EP_setDP}]]></script>
   </events>
  </shape>
  <shape layerId="0" Name="PRIMITIVE_TEXT12" shapeType="PRIMITIVE_TEXT">
   <properties>
    <prop name="serialId">46</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">21 206</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">46</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="DashBackColor">_Transparent</prop>
    <prop name="AntiAliased">False</prop>
    <prop name="LineType">[solid,oneColor,JoinBevel,CapButt,1]</prop>
    <prop name="BorderZoomable">False</prop>
    <prop name="FillType">[outline]</prop>
    <prop name="Location">21 206</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Text">
     <prop name="en_US.utf8">Buffer to disk status:</prop>
    </prop>
    <prop name="Distance">2</prop>
    <prop name="BorderOffset">2</prop>
    <prop name="Bordered">False</prop>
    <prop name="Fit">True</prop>
    <prop name="Transformable">True</prop>
    <prop name="TextFormat">[0s,,,AlignLeft]</prop>
   </properties>
  </shape>
  <shape layerId="0" Name="btn_fastFlush" shapeType="PUSH_BUTTON">
   <properties>
    <prop name="serialId">47</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">268 549</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_ButtonText</prop>
    <prop name="BackColor">_Button</prop>
    <prop name="TabOrder">47</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">280 201</prop>
    <prop name="Size">100 25</prop>
    <prop name="BorderStyle">Normal</prop>
    <prop name="Text">
     <prop name="en_US.utf8">Fast flush all</prop>
    </prop>
   </properties>
   <events>
    <script name="Clicked" isEscaped="1"><![CDATA[const int _MIN_BUFFS = 10;

main()
{
  int originalDbWriteDelay;
  dpGet(&quot;_RDBArchive.dbConfig.dbWriteDelay:_original.._value&quot;, originalDbWriteDelay);
  
  int nbBuffers, maxBuffers;
  dpGet(&quot;_RDBArchive.buffer.currentBlocks:_online.._value&quot;, nbBuffers);
  maxBuffers = nbBuffers;
  
  //fwOpenProgressBar(&quot;Fast flushing all buffers&quot;, &quot;Buffers remaining: &quot; + nbBuffers, 2);
  progressBar.totalSteps(100);
  progressBar.progress(0);
  feedbackText.text(&quot;Flushing: &quot; + nbBuffers + &quot; remaining&quot;);
  showUserFeedback(true);

  dpSetWait(&quot;_RDBArchive.dbConfig.dbWriteDelay:_original.._value&quot;, 0);
  dpSetWait(&quot;_RDBArchive.flushBuffer:_original.._value&quot;, true);
  while(nbBuffers &gt;= _MIN_BUFFS) {
    dpGet(&quot;_RDBArchive.buffer.currentBlocks:_online.._value&quot;, nbBuffers);
    if(nbBuffers &gt; maxBuffers)
      maxBuffers = nbBuffers;
    
    float maxBuffersMin = maxBuffers - _MIN_BUFFS;
    float percent = ((maxBuffersMin - nbBuffers + _MIN_BUFFS) / maxBuffersMin) * 100.0;
    //fwShowProgressBar(&quot;Buffers remaining: &quot; + nbBuffers, percent);
    progressBar.progress(percent);
    feedbackText.text(&quot;Flushing: &quot; + nbBuffers + &quot; remaining&quot;);
    delay(0, 1);
  }
  
  dpSetWait(&quot;_RDBArchive.dbConfig.dbWriteDelay:_original.._value&quot;, originalDbWriteDelay);
  
  //fwCloseProgressBar(&quot;Less then &quot; + _MIN_BUFFS + &quot; buffers remaining, back to normal&quot;);
  showUserFeedback(false);
}]]></script>
   </events>
  </shape>
  <shape layerId="0" Name="modeSelectionCombobox" shapeType="COMBO_BOX">
   <properties>
    <prop name="serialId">49</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">630 3</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">49</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">630 3</prop>
    <prop name="Size">125 23</prop>
    <prop name="Listitems">
     <prop name="Item">
      <prop name="Text">
       <prop name="en_US.utf8">Advanced mode</prop>
      </prop>
      <prop name="Select">False</prop>
     </prop>
     <prop name="Item">
      <prop name="Text">
       <prop name="en_US.utf8">Basic mode</prop>
      </prop>
      <prop name="Select">False</prop>
     </prop>
    </prop>
    <prop name="Editable">False</prop>
   </properties>
   <events>
    <script name="Changed" isEscaped="1"><![CDATA[main()
{
  switch(this.selectedPos())
  {
    case 1:
      RootPanelOn(&quot;fwRDBArchiver/fwRDBArchiver_Configuration.xml&quot;, &quot;RDB Configuration&quot;, &quot;&quot;);
      break;
    case 2:
      RootPanelOn(&quot;fwRDBArchiver/fwRDBArchiver_Overview.xml&quot;, &quot;RDB Overview&quot;, &quot;&quot;);
      break;
    default:
      break;
  }
}]]></script>
   </events>
  </shape>
  <reference referenceId="0" Name="PANEL_REF0" parentSerial="-1">
   <properties>
    <prop name="FileName">objects/fwGeneral/fwHelpButton.pnl</prop>
    <prop name="Location">760 10</prop>
    <prop name="Geometry">1 0 0 1 5 -8</prop>
    <prop name="TabOrder">50</prop>
    <prop name="dollarParameters">
     <prop name="dollarParameter">
      <prop name="Dollar">$sPanelRelativePath</prop>
      <prop name="Value">tbd</prop>
     </prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
   </properties>
  </reference>
  <shape layerId="0" Name="bgRectangle" shapeType="RECTANGLE">
   <properties>
    <prop name="serialId">51</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">20 530</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_Transparent</prop>
    <prop name="BackColor">FwCorporateColor</prop>
    <prop name="TabOrder">51</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="DashBackColor">_Transparent</prop>
    <prop name="AntiAliased">False</prop>
    <prop name="LineType">[solid,oneColor,JoinBevel,CapButt,1]</prop>
    <prop name="BorderZoomable">False</prop>
    <prop name="FillType">[solid]</prop>
    <prop name="Geometry">3.82392 0 0 1 -77.47839999999999 -531</prop>
    <prop name="BorderStyle">Normal</prop>
    <prop name="Location">20 530</prop>
    <prop name="Size">302 31</prop>
    <prop name="CornerRadius">0</prop>
    <prop name="Transformable">True</prop>
   </properties>
  </shape>
  <shape layerId="0" Name="title" shapeType="PRIMITIVE_TEXT">
   <properties>
    <prop name="serialId">52</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">8 2</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">white</prop>
    <prop name="BackColor">_Transparent</prop>
    <prop name="TabOrder">52</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="DashBackColor">_Transparent</prop>
    <prop name="AntiAliased">False</prop>
    <prop name="LineType">[solid,oneColor,JoinMiter,CapButt,1]</prop>
    <prop name="BorderZoomable">False</prop>
    <prop name="FillType">[outline]</prop>
    <prop name="Location">10 4</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,19,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Text">
     <prop name="en_US.utf8">JCOP Framework RDB Archiver Configuration</prop>
    </prop>
    <prop name="Distance">0</prop>
    <prop name="BorderOffset">2</prop>
    <prop name="Bordered">False</prop>
    <prop name="Fit">True</prop>
    <prop name="Transformable">True</prop>
    <prop name="TextFormat">[0s,,,AlignLeft]</prop>
   </properties>
  </shape>
  <shape layerId="0" Name="cancelButton" shapeType="PUSH_BUTTON">
   <properties>
    <prop name="serialId">53</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">715 255</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">False</prop>
    <prop name="ForeColor">_ButtonText</prop>
    <prop name="BackColor">_Button</prop>
    <prop name="TabOrder">53</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">715 255</prop>
    <prop name="Size">75 25</prop>
    <prop name="BorderStyle">Normal</prop>
    <prop name="Text">
     <prop name="en_US.utf8">Cancel</prop>
    </prop>
   </properties>
   <events>
    <script name="Clicked" isEscaped="1"><![CDATA[main()
{
  PanelOff();
}]]></script>
   </events>
  </shape>
  <shape layerId="0" Name="applyButton" shapeType="PUSH_BUTTON">
   <properties>
    <prop name="serialId">54</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">633 255</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">False</prop>
    <prop name="ForeColor">_ButtonText</prop>
    <prop name="BackColor">_Button</prop>
    <prop name="TabOrder">54</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">633 255</prop>
    <prop name="Size">75 25</prop>
    <prop name="BorderStyle">Normal</prop>
    <prop name="Text">
     <prop name="en_US.utf8">Apply</prop>
    </prop>
   </properties>
   <events>
    <script name="Clicked" isEscaped="1"><![CDATA[main()
{
  // to be implemented
}]]></script>
   </events>
  </shape>
  <shape layerId="0" Name="okButton" shapeType="PUSH_BUTTON">
   <properties>
    <prop name="serialId">55</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">551 255</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">False</prop>
    <prop name="ForeColor">_ButtonText</prop>
    <prop name="BackColor">_Button</prop>
    <prop name="TabOrder">55</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">551 255</prop>
    <prop name="Size">75 25</prop>
    <prop name="BorderStyle">Normal</prop>
    <prop name="Text">
     <prop name="en_US.utf8">OK</prop>
    </prop>
   </properties>
   <events>
    <script name="Clicked" isEscaped="1"><![CDATA[main()
{
  // to be implemented
}]]></script>
   </events>
  </shape>
  <shape layerId="0" Name="connectionStateText" shapeType="PRIMITIVE_TEXT">
   <properties>
    <prop name="serialId">56</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">31 44</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_Window</prop>
    <prop name="TabOrder">56</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="DashBackColor">_Transparent</prop>
    <prop name="AntiAliased">False</prop>
    <prop name="LineType">[solid,oneColor,JoinBevel,CapButt,1]</prop>
    <prop name="BorderZoomable">False</prop>
    <prop name="FillType">[outline]</prop>
    <prop name="Location">31 44</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Text">
     <prop name="en_US.utf8">Disconnected</prop>
    </prop>
    <prop name="Distance">2</prop>
    <prop name="BorderOffset">2</prop>
    <prop name="Bordered">False</prop>
    <prop name="Fit">True</prop>
    <prop name="Transformable">True</prop>
    <prop name="TextFormat">[0s,,,AlignLeft]</prop>
   </properties>
  </shape>
  <shape layerId="0" Name="connectionStateRectangle" shapeType="RECTANGLE">
   <properties>
    <prop name="serialId">57</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">270 310</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_Transparent</prop>
    <prop name="BackColor">red</prop>
    <prop name="TabOrder">57</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="DashBackColor">_Transparent</prop>
    <prop name="AntiAliased">False</prop>
    <prop name="LineType">[solid,oneColor,JoinBevel,CapButt,1]</prop>
    <prop name="BorderZoomable">False</prop>
    <prop name="FillType">[solid]</prop>
    <prop name="Geometry">1 0 0 1 -10 -246</prop>
    <prop name="BorderStyle">Normal</prop>
    <prop name="Location">20 290</prop>
    <prop name="Size">16 16</prop>
    <prop name="CornerRadius">0</prop>
    <prop name="Transformable">True</prop>
   </properties>
  </shape>
  <shape layerId="0" Name="seperatorLine" shapeType="LINE">
   <properties>
    <prop name="serialId">58</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">120 40</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">{0,0,0}</prop>
    <prop name="BackColor">{255,255,255}</prop>
    <prop name="TabOrder">58</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="DashBackColor">_Transparent</prop>
    <prop name="AntiAliased">False</prop>
    <prop name="LineType">[solid,oneColor,JoinBevel,CapButt,1]</prop>
    <prop name="BorderZoomable">False</prop>
    <prop name="Start">120 40</prop>
    <prop name="End">120 64</prop>
   </properties>
  </shape>
  <shape layerId="0" Name="currentBlocksField" shapeType="TEXT_FIELD">
   <properties>
    <prop name="serialId">59</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">130 300</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_3DFace</prop>
    <prop name="TabOrder">59</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">190 169</prop>
    <prop name="Size">80 23</prop>
    <prop name="BorderStyle">Normal</prop>
    <prop name="Editable">False</prop>
    <prop name="TextFormat">[0s,,,AlignLeft]</prop>
   </properties>
   <events>
    <script name="Initialize" isEscaped="1"><![CDATA[main()
{
  EP_textFieldIn();
}

EP_textFieldIn()
{
dyn_errClass err;

  if( !dpExists( &quot;_RDBArchive.buffer.currentBlocks:_online.._value&quot;))
  {
    setValue(&quot;&quot;, &quot;backCol&quot;, &quot;_dpdoesnotexist&quot;);
    return;
  }

  dpConnect(&quot;EP_textFieldInCB&quot;,
            &quot;_RDBArchive.buffer.currentBlocks:_online.._value&quot;);
  err = getLastError();
  if (dynlen(err) &gt; 0)
    setValue(&quot;&quot;, &quot;backCol&quot;, &quot;_dpdoesnotexist&quot;);

}


EP_textFieldInCB(string dp, int iNewValue)
{
  setValue(&quot;&quot;, &quot;text&quot;, dpValToString(dp, iNewValue, TRUE) );
}]]></script>
   </events>
  </shape>
  <shape layerId="0" Name="bufferStatusField" shapeType="TEXT_FIELD">
   <properties>
    <prop name="serialId">60</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">130 300</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">True</prop>
    <prop name="ForeColor">_WindowText</prop>
    <prop name="BackColor">_3DFace</prop>
    <prop name="TabOrder">60</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">190 202</prop>
    <prop name="Size">80 23</prop>
    <prop name="BorderStyle">Normal</prop>
    <prop name="Editable">False</prop>
    <prop name="TextFormat">[0s,,,AlignLeft]</prop>
   </properties>
   <events>
    <script name="Initialize" isEscaped="1"><![CDATA[main()
{
  EP_textFieldIn();
}

EP_textFieldIn()
{
dyn_errClass err;

  if( !dpExists( &quot;_RDBArchive.buffer.bufferToDiskIndicator:_online.._value&quot;))
  {
    setValue(&quot;&quot;, &quot;backCol&quot;, &quot;_dpdoesnotexist&quot;);
    return;
  }

  dpConnect(&quot;EP_textFieldInCB&quot;,
            &quot;_RDBArchive.buffer.bufferToDiskIndicator:_online.._value&quot;);
  err = getLastError();
  if (dynlen(err) &gt; 0)
    setValue(&quot;&quot;, &quot;backCol&quot;, &quot;_dpdoesnotexist&quot;);

}


EP_textFieldInCB(string dp, int iNewValue)
{
  string sVal;
  switch(iNewValue) {
    case 0:
      setValue(&quot;&quot;, &quot;text&quot;, &quot;Inactive&quot;);
      setValue(&quot;&quot;, &quot;backCol&quot;, &quot;green&quot;);
    break;
    case 1:
      setValue(&quot;&quot;, &quot;text&quot;, &quot;Active&quot;);
      setValue(&quot;&quot;, &quot;backCol&quot;, &quot;red&quot;);
    break;
    case 2:
      setValue(&quot;&quot;, &quot;text&quot;, &quot;Flushing&quot;);
      setValue(&quot;&quot;, &quot;backCol&quot;, &quot;yellow&quot;);
    break;
  }
}]]></script>
   </events>
  </shape>
  <shape layerId="0" Name="progressBar" shapeType="PROGRESS_BAR">
   <properties>
    <prop name="serialId">61</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">10 260</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">False</prop>
    <prop name="ForeColor">_3DText</prop>
    <prop name="BackColor">_3DFace</prop>
    <prop name="TabOrder">61</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Location">10 260</prop>
    <prop name="Size">250 15</prop>
    <extended>
     <prop name="percentageVisible" type="BOOL">False</prop>
    </extended>
   </properties>
  </shape>
  <shape layerId="0" Name="feedbackText" shapeType="PRIMITIVE_TEXT">
   <properties>
    <prop name="serialId">62</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">282 259</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">False</prop>
    <prop name="ForeColor">{0,0,0}</prop>
    <prop name="BackColor">_Transparent</prop>
    <prop name="TabOrder">62</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="DashBackColor">_Transparent</prop>
    <prop name="AntiAliased">False</prop>
    <prop name="LineType">[solid,oneColor,JoinMiter,CapButt,2]</prop>
    <prop name="BorderZoomable">False</prop>
    <prop name="FillType">[outline]</prop>
    <prop name="Location">282 259</prop>
    <prop name="Font">
     <prop name="en_US.utf8">Arial,-1,13,5,50,0,0,0,0,0</prop>
    </prop>
    <prop name="Text">
     <prop name="en_US.utf8">Connection configured.</prop>
    </prop>
    <prop name="Distance">0</prop>
    <prop name="BorderOffset">2</prop>
    <prop name="Bordered">False</prop>
    <prop name="Fit">True</prop>
    <prop name="Transformable">True</prop>
    <prop name="TextFormat">[0s,,,AlignLeft]</prop>
   </properties>
  </shape>
  <shape layerId="0" Name="feedbackArrow" shapeType="POLYGON">
   <properties>
    <prop name="serialId">63</prop>
    <prop name="Type"></prop>
    <prop name="RefPoint">10 770</prop>
    <prop name="Enable">True</prop>
    <prop name="Visible">False</prop>
    <prop name="ForeColor">_Transparent</prop>
    <prop name="BackColor">_3DText</prop>
    <prop name="TabOrder">63</prop>
    <prop name="ToolTipText">
     <prop name="en_US.utf8"></prop>
    </prop>
    <prop name="layoutAlignment">AlignCenter</prop>
    <prop name="snapMode">Point</prop>
    <prop name="DashBackColor">_Transparent</prop>
    <prop name="AntiAliased">False</prop>
    <prop name="LineType">[solid,oneColor,JoinBevel,CapButt,1]</prop>
    <prop name="BorderZoomable">False</prop>
    <prop name="FillType">[solid]</prop>
    <prop name="Geometry">0.725926 0 0 0.6825 262.741 -265.525</prop>
    <prop name="Closed">True</prop>
    <prop name="Points">
     <prop name="Location">10 770</prop>
     <prop name="Location">10 790</prop>
     <prop name="Location">20 780</prop>
     <prop name="Location">10 770</prop>
     <prop name="Location">10 790</prop>
    </prop>
   </properties>
  </shape>
 </shapes>
</panel>
